Subject: [RFC PATCH 0/1] add-patch: Allow reworking with a file after deciding on its hunks

From: Abraham Samuel Adekunle <[email-masked]>
Date: Fri, 23 Jan 2026 12:56:47 +0100

Hello,
In the discussion between Phillip Wood and Junio C Hamano in [1], Junio suggested
some enhancements to the UI of the add interactive.

They include;
i. Add a way to see the previous hunk decision of the current hunk after the
   user navigates back with K/J.
ii. Allow reworking with a file after deciding on all its hunks without
    auto advancing.
iii. When having multiple modified files, allow switching from the current file to
     another file whose hunks have already been decided.

I have been able to work on 'i' above in [2] and this RFC seeks to find suggestions
on 'ii' and maybe 'iii' as this enters design realms

The patch is in no way a final version. I just want to present something that
members giving suggestions can work with.

While trying to follow the suggestions in [1] in the patch, when all hunks
have been decided;
	* A what_now prompts appears, allowing navigation with J/K, q to quit
	and '>' to go to the next file if there is a next file

	* If K/J is used to return to a hunk from the what_now mode, after any new decision,
	on the hunk, the user is brought back to the what_now prompt since all hunks
	had previously been decided on.

I would appreciate your thoughts on this.
Thanks

1. https://lore.kernel.org/git/[email-masked]/
2. https://lore.kernel.org/git/[email-masked]/

Abraham Samuel Adekunle (1):
  add-patch: Allow reworking with a file after deciding on all its hunks

 add-patch.c | 71 ++++++++++++++++++++++++++++++++++++++++++++++++-----
 1 file changed, 65 insertions(+), 6 deletions(-)

-- 
2.39.5 (Apple Git-154)